diff -r 1d1c4c997b66 sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_input.c	Sun Aug 30 14:27:42 2015 +1000
@@ -1965,11 +2666,23 @@
 		if (!(thflags & TH_SYN))
 			goto drop;
 
+		/* Set initial receive values for tpcb and mpcb. initially we
+		 * are in infinite mapping mode so both set from tp->irs.
+		 * mp protocol specifies increment by 1. */
 		tp->irs = th->th_seq;
 		tcp_rcvseqinit(tp);
+        tp->t_mp_conn.ds_last_dsn = tp->rcv_nxt;
+//		if (tp->t_sf_flags & SFF_FIRSTSUBFLOW) {
+//			MP_INNER_LOCK(tp->t_mpcb);
+//			mp_rcvseqinit(tp->t_mpcb, tp);
+//			MP_INNER_UNLOCK(tp->t_mpcb);
+//		}
+
 		if (thflags & TH_ACK) {
 			TCPSTAT_INC(tcps_connects);
 			soisconnected(so);
+			printf("%s: connected tp %p so %p\n", __func__, tp, so);
+
 #ifdef MAC
 			mac_socketpeer_set_from_mbuf(m, so);
 #endif
@@ -1981,6 +2694,7 @@
 			tp->rcv_adv += imin(tp->rcv_wnd,
 			    TCP_MAXWIN << tp->rcv_scale);
 			tp->snd_una++;		/* SYN is acked */
+
 			/*
 			 * If there's data, delay ACK; if there's also a FIN
 			 * ACKNOW will be turned on later.
@@ -2014,6 +2728,28 @@
 				cc_conn_init(tp);
 				tcp_timer_activate(tp, TT_KEEP,
 				    TP_KEEPIDLE(tp));
+
+				/* MPTCP */
+				if (to.to_flags & TOF_MPTCP) {
+					/* Have also become an MPTCP connection. Let the mp
+					 * control layer know. */
+					if(tp->t_sf_flags & SFF_SENT_MPCAPABLE) {
+						tp->t_sf_flags &= ~SFF_INFINITEMAP;
+						tp->t_sf_state |= SFS_MP_ENABLED;
+						mp_wakeup |= tp_schedule_event(tp, SFE_MPESTABLISHED);
+					} else if(tp->t_sf_state & SFS_MP_CONNECTING) {
+						tp->t_sf_state &= ~SFS_MP_CONNECTING;
+						tp->t_sf_state |= SFS_MP_ENABLED;
+						mp_debug(MPSESSION, 1, 0,
+						    "%s:%d new mp connection for tp: %p: \n", __func__,
+						    __LINE__, tp);
+						mp_debug(MPSESSION, 4, 0,
+							"%s: set subflow as mp_active\n", __func__);
+					}
+				}
+				/* Let the mp control layer know that a subflow has
+				 * reached a connected state. */
+				mp_wakeup |= tp_schedule_event(tp, SFE_CONNECTED);
 			}
 		} else {
 			/*
@@ -2062,6 +2798,8 @@
 
 		goto step6;
 
+	/* Case SYN_SENT */
+
 	/*
 	 * If the state is LAST_ACK or CLOSING or TIME_WAIT:
 	 *      do normal processing.
@@ -2072,6 +2810,8 @@
 	case TCPS_CLOSING:
 		break;  /* continue normal processing */
 	}
+	/* End SYN/LISTEN processing */
+
 
 	/*
 	 * States other than LISTEN or SYN_SENT.
@@ -2089,6 +2829,8 @@
 	 * drop leading data (and SYN); if nothing left, just ack.
 	 */
 	if (thflags & TH_RST) {
+		printf("%s: got RST, tseq %u last_ack %u rcv_nxt %u\n", __func__,
+			th->th_seq, tp->last_ack_sent, tp->rcv_nxt);
 		/*
 		 * RFC5961 Section 3.2
 		 *
@@ -2129,9 +2871,18 @@
 					tcp_state_change(tp, TCPS_CLOSED);
 					/* FALLTHROUGH */
 				default:
+					printf("%s: close after RST\n", __func__);
 					tp = tcp_close(tp);
+
+					/* XXXNJW: This will ensure that a close is
+					 * called on the subflow socket, as the wakeups
+					 * (in tcp_drop) won't actually cause a close in this
+					 * case. */
+					if (tp->t_sf_state & SFS_MP_ENABLED)
+                        mp_wakeup |= MP_SCHEDCLOSE;
 				}
 			} else {
+				printf("%s: send RST challenge\n", __func__);
 				TCPSTAT_INC(tcps_badrst);
 				/* Send challenge ACK. */
 				tcp_respond(tp, mtod(m, void *), th, m,
@@ -2167,6 +2918,8 @@
 		}
 		goto drop;
 	}
+	/* End RST Processing */
+
 
 	/*
 	 * RFC 1323 PAWS: If we have a timestamp reply on this segment
@@ -2211,6 +2964,7 @@
 		goto dropwithreset;
 	}
 
+	/* Trimming to fit rcv window */
 	todrop = tp->rcv_nxt - th->th_seq;
 	if (todrop > 0) {
 		if (thflags & TH_SYN) {
@@ -2249,13 +3003,23 @@
 		drop_hdrlen += todrop;	/* drop from the top afterwards */
 		th->th_seq += todrop;
 		tlen -= todrop;
+
+		/* dsn should be incremented by the same length as th_seq */
+		if (map) {
+			struct m_tag *mtag =  m_tag_locate(m, PACKET_COOKIE_MPTCP,
+			    PACKET_TAG_DSN, NULL);
+			KASSERT(mtag != NULL, ("%s segment %u missing an mbuf tag\n",
+			    __func__, th->th_seq - todrop));
+			((struct dsn_tag *)mtag)->dsn += todrop;
+		}
+
 		if (th->th_urp > todrop)
 			th->th_urp -= todrop;
 		else {
 			thflags &= ~TH_URG;
 			th->th_urp = 0;
 		}
-	}
+	} /* end segment trimming, seq < rcv_nxt */
 
 	/*
 	 * If new data are received on a connection after the
@@ -2303,6 +3067,14 @@
 				goto dropafterack;
 		} else
 			TCPSTAT_ADD(tcps_rcvbyteafterwin, todrop);
+
+		//XXXNJW: Were issues with trimming the end of an incoming segment
+		// that would mess up the dsn/ssn mappings and cause a stall. This
+		// might have been fixed so should try removing this and testing.
+		// So what happens now is that segments that are trimmed due to having
+		// length past the rcv win are dropped altogether.
+		goto dropafterack;
+
 		m_adj(m, -todrop);
 		tlen -= todrop;
 		thflags &= ~(TH_PUSH|TH_FIN);
@@ -2360,7 +3132,6 @@
 	 * The ACK was checked above.
 	 */
 	case TCPS_SYN_RECEIVED:
-
 		TCPSTAT_INC(tcps_connects);
 		soisconnected(so);
 		/* Do window scaling? */
@@ -2384,14 +3155,47 @@
 			    mtod(m, const char *), tp, th);
 			cc_conn_init(tp);
 			tcp_timer_activate(tp, TT_KEEP, TP_KEEPIDLE(tp));
+
+			/* MPTCP */
+			mp_wakeup |= tp_schedule_event(tp, SFE_CONNECTED);
+			if (to.to_flags & TOF_MPTCP) {
+				/* Have also become an MPTCP connection. Let the mp
+				 * control layer know. */
+				if(tp->t_sf_flags &
+				    (SFF_SENT_MPCAPABLE | SFF_FIRSTSUBFLOW)) {
+					tp->t_sf_state &= ~SFS_MP_CONNECTING;
+					tp->t_sf_flags &= ~SFF_INFINITEMAP;
+					tp->t_sf_state |= SFS_MP_ENABLED;
+					mp_wakeup |= tp_schedule_event(tp, SFE_MPESTABLISHED);
+				} else if(!(tp->t_sf_flags & SFF_FIRSTSUBFLOW)
+			          && (tp->t_sf_state & SFS_MP_CONNECTING)) {
+					tp->t_sf_state &= ~SFS_MP_CONNECTING;
+					tp->t_sf_state |= SFS_MP_ENABLED;
+					mp_debug(MPSESSION, 1, 0,
+						"%s:%d new mp connection for tp: %p: \n", __func__,
+						__LINE__, tp);
+					mp_debug(MPSESSION, 4, 0, "%s: set subflow as mp_active\n",
+					    __func__);
+				}
+			}
 		}
 		/*
 		 * If segment contains data or ACK, will call tcp_reass()
 		 * later; if not, do so now to pass queued data to user.
 		 */
-		if (tlen == 0 && (thflags & TH_FIN) == 0)
+		if (tlen == 0 && (thflags & TH_FIN) == 0) {
 			(void) tcp_reass(tp, (struct tcphdr *)0, 0,
 			    (struct mbuf *)0);
+			if (tp->t_segq_received) {
+//				printf("%s:%d received seg sqn %u\n", __func__, __LINE__,
+//				    th->th_seq);
+				if (m_ptr == NULL)
+					m_ptr = tp->t_segq_received;
+				else
+					mp_appendpkt(m_ptr, tp->t_segq_received);
+				tp->t_segq_received = NULL;
+			}
+		}
 		tp->snd_wl1 = th->th_seq - 1;
 		/* FALLTHROUGH */
 
@@ -2422,9 +3226,9 @@
 		hhook_run_tcp_est_in(tp, th, &to);
 
 		if (SEQ_LEQ(th->th_ack, tp->snd_una)) {
-			if (tlen == 0 && tiwin == tp->snd_wnd) {
-				/*
-				 * If this is the first time we've seen a
+			if (tlen == 0 && tiwin == tp->snd_wnd) {      //XXXNJW
+				/*                                                 //must
+				 * If this is the first time we've seen a          //change (??)
 				 * FIN from the remote, this is not a
 				 * duplicate and it needs to be processed
 				 * normally.  This happens during a
@@ -2435,6 +3239,15 @@
 					tp->t_dupacks = 0;
 					break;
 				}
+
+				/* XXXNJW: don't want to mark MPTCP signal-only
+				 * packets as dupacks. Find a nicer way to deal with
+				 * this. What about dup DFINs? */
+				if (to.to_mopts.mpo_flags &
+				    (MPOF_DATA_ACK | MPOF_DSN_MAP | MPOF_DATA_FIN)) {
+					tp->t_dupacks = 0;
+				}
+
 				TCPSTAT_INC(tcps_rcvdupack);
 				/*
 				 * If we have outstanding data (other than
@@ -2583,7 +3396,7 @@
 			} else
 				tp->t_dupacks = 0;
 			break;
-		}
+		} /* end dup-ack processing */
 
 		KASSERT(SEQ_GT(th->th_ack, tp->snd_una),
 		    ("%s: th_ack <= snd_una", __func__));
@@ -2706,9 +3519,13 @@
 			tp->snd_wnd -= acked;
 			ourfinisacked = 0;
 		}
+		dsmap_drop(&tp->t_send_maps.dsmap_list, th->th_ack,
+		    (ourfinisacked ? (int)sbavail(&so->so_snd) : acked));
+
 		/* NB: sowwakeup_locked() does an implicit unlock. */
 		sowwakeup_locked(so);
 		m_freem(mfree);
+
 		/* Detect una wraparound. */
 		if (!IN_RECOVERY(tp->t_flags) &&
 		    SEQ_GT(tp->snd_una, tp->snd_recover) &&
@@ -2720,6 +3537,10 @@
 			EXIT_RECOVERY(tp->t_flags);
 		}
 		tp->snd_una = th->th_ack;
+
+		if ((tp->t_sf_state & SFS_MP_ENABLED) == 0)
+			mp_wakeup |= MP_SCHEDINPUT;
+
 		if (tp->t_flags & TF_SACK_PERMIT) {
 			if (SEQ_GT(tp->snd_una, tp->snd_recover))
 				tp->snd_recover = tp->snd_una;
@@ -2747,6 +3568,8 @@
 				 * we should release the tp also, and use a
 				 * compressed state.
 				 */
+				mp_debug(MPSESSION, 1, 0,
+				    "%s: FIN is acked, enter FINWAIT_2 tp %p\n", __func__, tp);
 				if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
 					soisdisconnected(so);
 					tcp_timer_activate(tp, TT_2MSL,
@@ -2766,10 +3589,17 @@
 		 */
 		case TCPS_CLOSING:
 			if (ourfinisacked) {
+				if (tp->t_sf_state & SFS_MP_ENABLED)
+					mp_wakeup |= MP_SCHEDDETACH;
 				INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 				tcp_twstart(tp);
 				INP_INFO_WUNLOCK(&V_tcbinfo);
 				m_freem(m);
+				if (mp_wakeup)
+					goto mp_input;
+				else
+					mpp_pcbrele_unlocked(mp->mp_mppcb);
+
 				return;
 			}
 			break;
@@ -2782,8 +3612,21 @@
 		 */
 		case TCPS_LAST_ACK:
 			if (ourfinisacked) {
+				printf("%s: subflow acked in LAST_ACK tp %p\n", __func__, tp);
 				INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
+				/* XXXNJW: to change.
+				 * For MP connections we track the count of subflows
+				 * and decrement as they close (in another thread).
+				 * Also clear the "MP_SCHEDINPUT" so we don't trigger
+				 * input processing in response to earlier segment
+				 * processing (as the inpcb/tcpcb won't exist soon
+				 * anyway) */
 				tp = tcp_close(tp);
+				mp_wakeup &= ~MP_SCHEDINPUT;
+				if (tp != NULL)
+					mp_wakeup |= MP_SCHEDCLOSE; /* Cases of disconnect only */
+				else
+					mp_wakeup |= MP_SCHEDDETACH;
 				goto drop;
 			}
 			break;
@@ -2880,7 +3723,7 @@
 
 	/*
 	 * Process the segment text, merging it into the TCP sequencing queue,
-	 * and arranging for acknowledgment of receipt if necessary.
+	 * and arranging for acknowledgement of receipt if necessary.
 	 * This process logically involves adjusting tp->rcv_wnd as data
 	 * is presented to the user (this happens in tcp_usrreq.c,
 	 * case PRU_RCVD).  If a FIN has already been received on this
@@ -2890,7 +3733,11 @@
 	    TCPS_HAVERCVDFIN(tp->t_state) == 0) {
 		tcp_seq save_start = th->th_seq;
 		m_adj(m, drop_hdrlen);	/* delayed header drop */
+		if (thflags & TH_FIN)
+			mp_debug(MPSESSION, 1, 0, "%s:%d: got FIN on tp %p\n", __func__,
+			    __LINE__, tp);
 		/*
+		 * XXXNJW: Need to adapt this comment
 		 * Insert segment which includes th into TCP reassembly queue
 		 * with control block tp.  Set thflags to whether reassembly now
 		 * includes a segment with FIN.  This handles the common case
@@ -2902,34 +3749,74 @@
 		 * immediately when segments are out of order (so
 		 * fast retransmit can work).
 		 */
+//		if (th->th_seq == tp->rcv_nxt && tp->t_segq == NULL &&
+//		    TCPS_HAVEESTABLISHED(tp->t_state)) {
+//			if (DELAY_ACK(tp, tlen))
+//				tp->t_flags |= TF_DELACK;
+//			else
+//				tp->t_flags |= TF_ACKNOW;
+//			tp->rcv_nxt += tlen;
+//			thflags = th->th_flags & TH_FIN;
+//			TCPSTAT_INC(tcps_rcvpack);
+//			TCPSTAT_ADD(tcps_rcvbyte, tlen);
+//			ND6_HINT(tp);
+//			SOCKBUF_LOCK(&so->so_rcv);
+//			if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
+//				m_freem(m);
+//			else
+//				sbappendstream_locked(&so->so_rcv, m);
+//			/* NB: sorwakeup_locked() does an implicit unlock. */
+//			sorwakeup_locked(so);
+//		} else {
+//			/*
+//			 * XXX: Due to the header drop above "th" is
+//			 * theoretically invalid by now.  Fortunately
+//			 * m_adj() doesn't actually frees any mbufs
+//			 * when trimming from the head.
+//			 */
+//			thflags = tcp_reass(tp, th, &tlen, m);
+//			tp->t_flags |= TF_ACKNOW;
+//		}
+
+        /* XXXNJW: Currently for MPTCP, always insert into the list.
+         * TCP reass checks for TCPS established and queues pre-established
+         * segments that have len.
+         */
 		if (th->th_seq == tp->rcv_nxt && tp->t_segq == NULL &&
-		    TCPS_HAVEESTABLISHED(tp->t_state)) {
-			if (DELAY_ACK(tp, tlen))
-				tp->t_flags |= TF_DELACK;
-			else
-				tp->t_flags |= TF_ACKNOW;
-			tp->rcv_nxt += tlen;
-			thflags = th->th_flags & TH_FIN;
+			TCPS_HAVEESTABLISHED(tp->t_state)) {
 			TCPSTAT_INC(tcps_rcvpack);
 			TCPSTAT_ADD(tcps_rcvbyte, tlen);
-			ND6_HINT(tp);
-			SOCKBUF_LOCK(&so->so_rcv);
-			if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
-				m_freem(m);
+	        if (DELAY_ACK(tp, tlen))
+	            tp->t_flags |= TF_DELACK;
+		    else
+			    tp->t_flags |= TF_ACKNOW;
+		} else /* Out-of-order segment, ACK straight away */
+			tp->t_flags |= TF_ACKNOW;
+
+        /*
+		 * XXX: Due to the header drop above "th" is
+		 * theoretically invalid by now.  Fortunately
+		 * m_adj() doesn't actually frees any mbufs
+		 * when trimming from the head.
+		 */
+//		if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
+//			m_freem(m);
+//		} else {
+		    if (tlen)
+			    thflags = tcp_reass(tp, th, &tlen, m);
+		    else
+		    	thflags = th->th_flags & TH_FIN;
+//		}
+
+		if (tp->t_segq_received) {
+//			printf("%s: received seg sqn %u\n", __func__, th->th_seq);
+			if (m_ptr == NULL)
+			    m_ptr = tp->t_segq_received;
 			else
-				sbappendstream_locked(&so->so_rcv, m, 0);
-			/* NB: sorwakeup_locked() does an implicit unlock. */
-			sorwakeup_locked(so);
-		} else {
-			/*
-			 * XXX: Due to the header drop above "th" is
-			 * theoretically invalid by now.  Fortunately
-			 * m_adj() doesn't actually frees any mbufs
-			 * when trimming from the head.
-			 */
-			thflags = tcp_reass(tp, th, &tlen, m);
-			tp->t_flags |= TF_ACKNOW;
+				mp_appendpkt(m_ptr, tp->t_segq_received);
+			tp->t_segq_received = NULL;
 		}
+
 		if (tlen > 0 && (tp->t_flags & TF_SACK_PERMIT))
 			tcp_update_sack_list(tp, save_start, save_start + tlen);
 #if 0
@@ -2996,13 +3883,19 @@
 		 * standard timers.
 		 */
 		case TCPS_FIN_WAIT_2:
+			if (tp->t_sf_state & SFS_MP_ENABLED)
+				mp_wakeup |= MP_SCHEDDETACH;
 			INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 			KASSERT(ti_locked == TI_WLOCKED, ("%s: dodata "
 			    "TCP_FIN_WAIT_2 ti_locked: %d", __func__,
 			    ti_locked));
-
 			tcp_twstart(tp);
 			INP_INFO_WUNLOCK(&V_tcbinfo);
+			if (mp_wakeup)
+				goto mp_input;
+			else
+				mpp_pcbrele_unlocked(mp->mp_mppcb);
+
 			return;
 		}
 	}
@@ -3032,8 +3925,15 @@
 		tp->t_flags &= ~TF_DELACK;
 		tcp_timer_activate(tp, TT_DELACK, tcp_delacktime);
 	}
+
 	INP_WUNLOCK(tp->t_inpcb);
-	return;
+
+	if (m_ptr || mp_wakeup)
+		goto mp_input;
+	else
+		mpp_pcbrele_unlocked(mp->mp_mppcb);
+
+    return;
 
 dropafterack:
 	/*
@@ -3068,8 +3968,15 @@
 
 	tp->t_flags |= TF_ACKNOW;
 	(void) tcp_output(tp);
-	INP_WUNLOCK(tp->t_inpcb);
-	m_freem(m);
+
+    INP_WUNLOCK(tp->t_inpcb);
+    m_freem(m);
+
+	if (m_ptr || mp_wakeup)
+		goto mp_input;
+	else
+		mpp_pcbrele_unlocked(mp->mp_mppcb);
+
 	return;
 
 dropwithreset:
@@ -3080,8 +3987,15 @@
 	if (tp != NULL) {
 		tcp_dropwithreset(m, th, tp, tlen, rstreason);
 		INP_WUNLOCK(tp->t_inpcb);
-	} else
+		/* Further processing at mp-layer */
+		if (m_ptr || mp_wakeup)
+			goto mp_input;
+		else
+			mpp_pcbrele_unlocked(mp->mp_mppcb);
+	} else {
 		tcp_dropwithreset(m, th, NULL, tlen, rstreason);
+		mpp_pcbrele_unlocked(mp->mp_mppcb);
+	}
 	return;
 
 drop:
@@ -3105,6 +4019,46 @@
 	if (tp != NULL)
 		INP_WUNLOCK(tp->t_inpcb);
 	m_freem(m);
+
+	/* Further processing at mp-layer */
+	/* Might we want to wakeup even when a tp has been de-alloced? */
+    if (m_ptr || mp_wakeup)
+        goto mp_input;
+    else
+    	mpp_pcbrele_unlocked(mp->mp_mppcb);
+
+    return;
+
+    /* XXXNJW: Kind of a stop-gap way to trigger appropriate tasks
+     * at the MP-layer. To re-think. (Perhaps an mptcp-specific
+     * upcall?) */
+mp_input:
+	MPP_LOCK(mp->mp_mppcb);
+
+	/* If this was the last reference on the mpp, then the session
+	 * has ended and we just return now. (all the data structures
+	 * will have been freed by now). */
+	if (mpp_pcbrele(mp->mp_mppcb)) {
+		printf("%s: freed mpp %p mp %p\n", __func__, mp->mp_mppcb, mp);
+		return;
+	}
+
+	if (m_ptr) {
+	    mp_mbuf_enqueue(mp, m_ptr);
+        mp_wakeup |= MP_SCHEDINPUT;
+	}
+	if ((mp_wakeup & (MP_SCHEDINPUT|MP_SCHEDEVENT|MP_SCHEDJOIN)) != 0)
+	    mp_schedule_tasks(mp, mp_wakeup);
+
+	/* XXNJW: Might have some tasks that can be performed right now.
+	 * this is just a cheap workaround until better monitoring of
+	 * the subflow socket is implemented (say to pick up on
+	 * soisdisconnected and that sort of thing) */
+	if ((mp_wakeup & (MP_SCHEDDETACH | MP_SCHEDCLOSE)) != 0)
+		if (mp_do_task_now(mp, mp_wakeup))
+			return;
+
+	MPP_UNLOCK(mp->mp_mppcb);
 }
 
 /*
@@ -3179,7 +4133,9 @@
 tcp_dooptions(struct tcpopt *to, u_char *cp, int cnt, int flags)
 {
 	int opt, optlen;
-
+	uint8_t subtype;
+
+	to->to_mopts.mpo_flags = 0;
 	to->to_flags = 0;
 	for (; cnt > 0; cnt -= optlen, cp += optlen) {
 		opt = cp[0];
@@ -3224,6 +4180,13 @@
 			    (char *)&to->to_tsecr, sizeof(to->to_tsecr));
 			to->to_tsecr = ntohl(to->to_tsecr);
 			break;
+		case TCPOPT_MPTCP:
+			bcopy((char *)cp + 2,
+					(char *)&subtype, sizeof(subtype));
+			if (optlen > MAX_MP_OPLEN)
+				continue;
+			mp_dosubtypes(to, subtype, cp, opt, optlen, flags);
+			break;
 #ifdef TCP_SIGNATURE
 		/*
 		 * XXX In order to reply to a host which has set the
@@ -3379,6 +4342,14 @@
 	tp->t_softerror = 0;
 }
 
+static int
+tp_schedule_event(struct tcpcb *tp, int event)
+{
+	tp->t_event_flags |= event;
+    tp->t_event_pending = 1;
+	return MP_SCHEDEVENT;
+}
+
 /*
  * Determine a reasonable value for maxseg size.
  * If the route is known, check route for mtu.
